diff --git a/examples/demos/lightningviewer/controller.cpp b/examples/demos/lightningviewer/controller.cpp
index c08584d1..e769d437 100644
--- a/examples/demos/lightningviewer/controller.cpp
+++ b/examples/demos/lightningviewer/controller.cpp
@@ -2,9 +2,9 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 
 #include "controller.h"
-#include "data/laststrikeinfo.h"
-#include "models/lightningitemmodel.h"
-#include "providers/lightningprovider.h"
+#include "laststrikeinfo.h"
+#include "lightningitemmodel.h"
+#include "lightningprovider.h"
 
 #include <QGeoPositionInfoSource>
 
@@ -109,3 +109,5 @@ void Controller::setDistanceTimeLayerEnabled(bool enabled)
 
     updateDistanceTime();
 }
+
+#include "moc_controller.cpp"
diff --git a/examples/demos/lightningviewer/controller.h b/examples/demos/lightningviewer/controller.h
index 1ab191b8..8c81b303 100644
--- a/examples/demos/lightningviewer/controller.h
+++ b/examples/demos/lightningviewer/controller.h
@@ -4,12 +4,13 @@
 #ifndef CONTROLLER_H
 #define CONTROLLER_H
 
-#include "data/laststrikeinfo.h"
-#include "models/lightningitemmodel.h"
-#include "providers/lightningprovider.h"
+#include "laststrikeinfo.h"
+#include "lightningitemmodel.h"
+#include "lightningprovider.h"
 
 #include <QObject>
 #include <QTime>
+#include <QtQmlIntegration>
 
 QT_BEGIN_NAMESPACE
 class QGeoPositionInfo;
@@ -26,6 +27,8 @@ class Controller : public QObject
     Q_PROPERTY(int lastStrikeTime READ getLastStrikeTime NOTIFY lastStrikeInfoUpdated FINAL)
     Q_PROPERTY(double lastStrikeDirection READ getLastStrikeDirection NOTIFY lastStrikeInfoUpdated FINAL)
     Q_PROPERTY(bool distanceTimeLayerEnabled READ isDistanceTimeLayerEnabled WRITE setDistanceTimeLayerEnabled NOTIFY distanceTimeLayerEnabledChanged FINAL)
+    QML_NAMED_ELEMENT(LightningController)
+    QML_SINGLETON
 
 public:
     explicit Controller(QObject *parent = nullptr);
diff --git a/examples/demos/lightningviewer/data/lightningitemdata.h b/examples/demos/lightningviewer/lightningitemdata.h
similarity index 97%
rename from examples/demos/lightningviewer/data/lightningitemdata.h
rename to examples/demos/lightningviewer/lightningitemdata.h
index f393e377..946bcd69 100644
--- a/examples/demos/lightningviewer/data/lightningitemdata.h
+++ b/examples/demos/lightningviewer/lightningitemdata.h
@@ -5,6 +5,7 @@
 #define LIGHTNINGITEMDATA_H
 
 #include <QGeoCoordinate>
+#include <chrono>
 
 struct LightningItemData
 {
diff --git a/examples/demos/lightningviewer/models/lightningitemmodel.cpp b/examples/demos/lightningviewer/lightningitemmodel.cpp
similarity index 98%
rename from examples/demos/lightningviewer/models/lightningitemmodel.cpp
rename to examples/demos/lightningviewer/lightningitemmodel.cpp
index 6ac1d6b0..0c3c77ca 100644
--- a/examples/demos/lightningviewer/models/lightningitemmodel.cpp
+++ b/examples/demos/lightningviewer/lightningitemmodel.cpp
@@ -2,7 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 
 #include "lightningitemmodel.h"
-#include "../data/laststrikeinfo.h"
+#include "laststrikeinfo.h"
 
 #include <QGeoPositionInfo>
 
diff --git a/examples/demos/lightningviewer/models/lightningitemmodel.h b/examples/demos/lightningviewer/lightningitemmodel.h
similarity index 96%
rename from examples/demos/lightningviewer/models/lightningitemmodel.h
rename to examples/demos/lightningviewer/lightningitemmodel.h
index 35a154d2..23c38265 100644
--- a/examples/demos/lightningviewer/models/lightningitemmodel.h
+++ b/examples/demos/lightningviewer/lightningitemmodel.h
@@ -4,7 +4,7 @@
 #ifndef LIGHTNINGITEMMODEL_H
 #define LIGHTNINGITEMMODEL_H
 
-#include "../data/lightningitemdata.h"
+#include "lightningitemdata.h"
 
 #include <QAbstractListModel>
 
diff --git a/examples/demos/lightningviewer/providers/lightningprovider.h b/examples/demos/lightningviewer/lightningprovider.h
similarity index 95%
rename from examples/demos/lightningviewer/providers/lightningprovider.h
rename to examples/demos/lightningviewer/lightningprovider.h
index 3929d278..7a9067f4 100644
--- a/examples/demos/lightningviewer/providers/lightningprovider.h
+++ b/examples/demos/lightningviewer/lightningprovider.h
@@ -4,7 +4,7 @@
 #ifndef LIGHTNINGPROVIDER_H
 #define LIGHTNINGPROVIDER_H
 
-#include "../data/lightningitemdata.h"
+#include "lightningitemdata.h"
 
 #include <QObject>
 
diff --git a/examples/demos/lightningviewer/lv_style/CMakeLists.txt b/examples/demos/lightningviewer/lv_style/CMakeLists.txt
new file mode 100644
index 00000000..34cfeaec
--- /dev/null
+++ b/examples/demos/lightningviewer/lv_style/CMakeLists.txt
@@ -0,0 +1,135 @@
+# Copyright (C) 2024 The Qt Company Ltd.
+# SPDX-License-Identifier: BSD-3-Clause
+
+if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
+    message(FATAL_ERROR "This module should be build as part of the 'lightningviewer' example, and not in isolation.")
+endif()
+
+set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/demos/lightningviewer/lv_style")
+
+set_source_files_properties(Config.qml
+    PROPERTIES
+        QT_QML_SINGLETON_TYPE TRUE
+)
+
+qt_add_qml_module(lightningviewer_style
+    URI "lv_style"
+    PLUGIN_TARGET lightningviewer_style
+    QML_FILES
+        Button.qml
+        Config.qml
+        RoundButton.qml
+        StyleImage.qml
+    RESOURCES
+        dark/images/roundbutton-background-checked-disabled@2x.png
+        dark/images/button-background-checked-hovered.png
+        dark/images/roundbutton-background-checked-disabled.png
+        dark/images/flatbutton-background.png
+        dark/images/flatbutton-background-disabled.png
+        dark/images/flatbutton-background-checked-pressed.png
+        dark/images/button-background.png
+        dark/images/flatbutton-background-hovered.png
+        dark/images/button-background-checked-hovered@2x.png
+        dark/images/roundbutton-background-checked-hovered.png
+        dark/images/button-background-checked.png
+        dark/images/flatbutton-background-checked-hovered@2x.png
+        dark/images/roundbutton-background-disabled.png
+        dark/images/flatbutton-background-disabled@2x.png
+        dark/images/roundbutton-background@2x.png
+        dark/images/flatbutton-background-checked-pressed@2x.png
+        dark/images/button-background@2x.png
+        dark/images/button-background-hovered@2x.png
+        dark/images/roundbutton-background-checked-pressed.png
+        dark/images/roundbutton-background-hovered.png
+        dark/images/roundbutton-background-checked.png
+        dark/images/flatbutton-background-checked@2x.png
+        dark/images/roundbutton-background.png
+        dark/images/button-background-pressed@2x.png
+        dark/images/roundbutton-background-disabled@2x.png
+        dark/images/flatbutton-background-checked.png
+        dark/images/button-background-disabled.png
+        dark/images/roundbutton-background-pressed@2x.png
+        dark/images/flatbutton-background-checked-disabled.png
+        dark/images/roundbutton-background-checked@2x.png
+        dark/images/roundbutton-background-checked-hovered@2x.png
+        dark/images/button-background-hovered.png
+        dark/images/flatbutton-background-checked-disabled@2x.png
+        dark/images/button-background-checked-disabled@2x.png
+        dark/images/button-background-checked-disabled.png
+        dark/images/button-background-checked-pressed@2x.png
+        dark/images/flatbutton-background@2x.png
+        dark/images/button-background-checked@2x.png
+        dark/images/button-background-pressed.png
+        dark/images/button-background-checked-pressed.png
+        dark/images/button-background-disabled@2x.png
+        dark/images/flatbutton-background-pressed.png
+        dark/images/flatbutton-background-checked-hovered.png
+        dark/images/flatbutton-background-pressed@2x.png
+        dark/images/roundbutton-background-pressed.png
+        dark/images/roundbutton-background-checked-pressed@2x.png
+        dark/images/flatbutton-background-hovered@2x.png
+        dark/images/roundbutton-background-hovered@2x.png
+        light/images/roundbutton-background-checked-disabled@2x.png
+        light/images/button-background-checked-hovered.png
+        light/images/roundbutton-background-checked-disabled.png
+        light/images/flatbutton-background.png
+        light/images/flatbutton-background-disabled.png
+        light/images/flatbutton-background-checked-pressed.png
+        light/images/button-background.png
+        light/images/flatbutton-background-hovered.png
+        light/images/button-background-checked-hovered@2x.png
+        light/images/roundbutton-background-checked-hovered.png
+        light/images/button-background-checked.png
+        light/images/flatbutton-background-checked-hovered@2x.png
+        light/images/roundbutton-background-disabled.png
+        light/images/flatbutton-background-disabled@2x.png
+        light/images/roundbutton-background@2x.png
+        light/images/flatbutton-background-checked-pressed@2x.png
+        light/images/button-background@2x.png
+        light/images/button-background-hovered@2x.png
+        light/images/roundbutton-background-checked-pressed.png
+        light/images/roundbutton-background-hovered.png
+        light/images/roundbutton-background-checked.png
+        light/images/flatbutton-background-checked@2x.png
+        light/images/roundbutton-background.png
+        light/images/button-background-pressed@2x.png
+        light/images/roundbutton-background-disabled@2x.png
+        light/images/flatbutton-background-checked.png
+        light/images/button-background-disabled.png
+        light/images/roundbutton-background-pressed@2x.png
+        light/images/flatbutton-background-checked-disabled.png
+        light/images/roundbutton-background-checked@2x.png
+        light/images/roundbutton-background-checked-hovered@2x.png
+        light/images/button-background-hovered.png
+        light/images/flatbutton-background-checked-disabled@2x.png
+        light/images/button-background-checked-disabled@2x.png
+        light/images/button-background-checked-disabled.png
+        light/images/button-background-checked-pressed@2x.png
+        light/images/flatbutton-background@2x.png
+        light/images/button-background-checked@2x.png
+        light/images/button-background-pressed.png
+        light/images/button-background-checked-pressed.png
+        light/images/button-background-disabled@2x.png
+        light/images/flatbutton-background-pressed.png
+        light/images/flatbutton-background-checked-hovered.png
+        light/images/flatbutton-background-pressed@2x.png
+        light/images/roundbutton-background-pressed.png
+        light/images/roundbutton-background-checked-pressed@2x.png
+        light/images/flatbutton-background-hovered@2x.png
+        light/images/roundbutton-background-hovered@2x.png
+)
+
+target_link_libraries(lightningviewer_style PRIVATE
+    Qt6::Core
+    Qt6::Gui
+    Qt6::Quick
+)
+
+install(TARGETS lightningviewer_style
+    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
+    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
+    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
+)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir
+    DESTINATION "${INSTALL_EXAMPLEDIR}"
+)
diff --git a/examples/demos/lightningviewer/main.cpp b/examples/demos/lightningviewer/main.cpp
index c17f1a04..e5628998 100644
--- a/examples/demos/lightningviewer/main.cpp
+++ b/examples/demos/lightningviewer/main.cpp
@@ -1,31 +1,22 @@
 // Copyright (C) 2023 The Qt Company Ltd.
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 
-#include "controller.h"
-
 #include <QGuiApplication>
 #include <QQmlApplicationEngine>
-#include <QQmlContext>
-
+#include <QDir>
 
 int main(int argc, char *argv[])
 {
     QGuiApplication app(argc, argv);
-
-    Q_INIT_RESOURCE(resources);
-    Q_INIT_RESOURCE(lv_style);
-
-    Controller controller;
-
+    app.setOrganizationName("QtProject");
+    app.setOrganizationDomain("qt-project.org");
+    app.setApplicationName(QFileInfo(app.applicationFilePath()).baseName());
     QQmlApplicationEngine engine;
     QObject::connect(&engine, &QQmlApplicationEngine::objectCreationFailed,
         &app, []() { QCoreApplication::exit(-1); },
         Qt::QueuedConnection);
 
-    QQmlContext *context = engine.rootContext();
-    context->setContextProperty("LightningController", &controller);
-
-    engine.loadFromModule("LightningViewer", "LightningView");
+    engine.loadFromModule("lightningviewer", "Main");
 
     return app.exec();
 }
